const gulp = require('gulp')
	, browsersync = require('browser-sync').create()
	, path = require('path')
	, webpack = require('webpack-stream')
	, sass = require('gulp-sass')
	, autoprefixer = require('gulp-autoprefixer')
	, jshint = require('gulp-jshint')
	, jshintStylish = require('jshint-stylish')
	, sourcemaps = require('gulp-sourcemaps')
	, scsslint = require('gulp-scss-lint')
	, browserify = require('browserify')
	, source = require('vinyl-source-stream')
	, watchify = require('watchify')
	, reactify = require('reactify')
	, babelify = require('babelify');

	var files = {
		'src': {
			'styles': './src/scss'
		},
		'dest': {
			'styles': './dist/styles'
		}
	};

gulp.task('sass', function() {
	console.info('compiling sass');
	return gulp.src(files.src.styles + '/app.scss')
		.pipe(sourcemaps.init())
		.pipe(sass().on('error', sass.logError))
		.pipe(sourcemaps.write())
		.pipe(autoprefixer({
			browsers: ['last 2 versions', 'Explorer 9']
		}))
		.pipe(sass())
		.pipe(gulp.dest(files.dest.styles))
		.pipe(browsersync.reload({stream: true}));

});





var bundler = watchify(browserify({
	entries: ['./src/audit/app.jsx'],
	transform: [reactify, [babelify, {
		"presets": ["es2015"]
	}]],
	extensions: ['.jsx'],
	debug: true,
	cache: {},
	packageCache: {},
	fullPaths: true
}));
function notify(err){
	console.error('error', err)
}
function bundle() {
	   bundler
		.bundle()
		.on('error', notify)
		.pipe(source('app.js'))
		.pipe(gulp.dest('./src/audit/build'))
}
bundler.on('update', bundle)

gulp.task('build', function() {
	console.log('building!');
	bundle()
});
